#Servidor de events ubicat en 'localhost' i port 1235
import proxyServidor
import threading

class publicador(threading.Thread):
	def __init__(self,taula_subscrits,topico,nom_objecte, missatge):
		threading.Thread.__init__(self)		
		self.taula_subscrits=taula_subscrits
		self.topico=topico
		self.nom_objecte=nom_objecte
		self.missatge=missatge
	def run(self):
		for name in self.taula_subscrits[self.topico]:                	
				self.taula_subscrits[self.topico][name].notify(self.nom_objecte,self.missatge)
				#print "Notifico publicacion a " + name

		
class se():
	def __init__(self):
		self.taula_ref = {}
		self.taula_cnt = {}
	#Mantindrem la llista dels servidors de noms subscrits a un topic
	def subscribe(self, topic, subscriber):
		if topic in self.taula_ref:
                	self.taula_ref[topic][self.taula_cnt[topic]]=subscriber
			self.taula_cnt[topic]=self.taula_cnt[topic]+1
		else:
			self.taula_ref[topic]={}
			self.taula_cnt[topic]=0
                	self.taula_ref[topic][self.taula_cnt[topic]]=subscriber
			self.taula_cnt[topic]=self.taula_cnt[topic]+1              
                return "Has quedado suscrito al topico " + topic
        #Informa als servidors de noms subscrits a un topic d'un event nou
	def publish(self,topic, nom_objecte, missatge):
		t=publicador(self.taula_ref,topic,nom_objecte, missatge)
		t.start()
		return "Funcion publicada"

s = proxyServidor.Proxy("localhost", 1235)
s.registrar(se(),"se")
s.servidor()
